// Edited 3/17/2015 - 4 space tab spacing

#include "pinio.h"
#include "simpletools.h"

static char ps_is_on = 0;

/// step/psu timeout
volatile uint8_t psu_timeout = 0;

void power_on()
{
	if(ps_is_on == 0)
	{
		#ifdef PS_ON_PIN

		set_direction(PS_ON_PIN, 1);
		set_output(PS_ON_PIN, 0);

		pause(500);

		#endif

		#ifdef PS_MOSFET_PIN

		set_output(PS_MOSFET_PIN, 1);

		pause(10);

		#endif

		ps_is_on = 1;
	}

	psu_timeout = 0;
}

void power_off()
{
	stepper_disable();
	x_disable();
	y_disable();
	z_disable();
	e_disable();

	#ifdef PS_ON_PIN

	set_direction(PS_ON_PIN, 0);

	#endif

	#ifdef PS_MOSFET_PIN

	set_output(PS_MOSFET_PIN, 0);

	#endif

	ps_is_on = 0;
}