

/** \file
	\brief Monitor and process the queue
*/

#include "queue_monitor.h"
#include "dda_queue.h"

/// cog variables
static int queue_monitor_cog = 0;
static int queue_monitor_stack[150];
//static int queue_monitor_stack[340];

void queue_monitor(void *par);

void queue_monitor_init()
{
	if(queue_monitor_cog == 0)
	{
		queue_monitor_cog = 1 + cogstart(&queue_monitor, NULL,
			queue_monitor_stack, sizeof queue_monitor_stack);
	}
}

/// stop monitoring the queue
void queue_monitor_stop()
{
	if(queue_monitor_cog > 0)
	{
		cogstop(queue_monitor_cog - 1);
		queue_monitor_cog = 0;
	}
}

/// start monitoring the queue
void queue_monitor(void *par)
{
//	while(1)
//	{
		if(queue_empty() == 0)
		{
			uint8_t isdead;

			static volatile unsigned int queue_monitor_lockID;

			queue_monitor_lockID = locknew();
			while(lockset(queue_monitor_lockID));
 
			isdead = (movebuffer[mb_tail].live == 0);

			lockclr(queue_monitor_lockID);
			lockret(queue_monitor_lockID);
  
			if(isdead)
			{
				next_move();
			}
		}
//	} 
}