

/** \file
	\brief Timer management - system clock
*/

#include "timer.h"
#include "config.h"
#include "time_clock.h"
#include "dda_queue.h"

/// cog variables
static int timer_cog = 0;
static int timer_stack[60];

void timer(void *par);

/// initialise timer and enable system clock interrupt.
/// step interrupt is enabled later when we start using it
void timer_init()
{
	if(timer_cog == 0)
	{
		timer_cog = 1 + cogstart(&timer, NULL, timer_stack, sizeof timer_stack);
	}
}

/// stop timers - emergency stop
void timer_stop()
{
	if(timer_cog > 0)
	{
		cogstop(timer_cog - 1);
		timer_cog = 0;
	}
}

/// set state of the clock flags
void timer(void *par)
{
	while(1)
	{
		waitcnt(TICK_TIME + CNT);

		clock_tick();
		dda_clock();
	}                            
}